'****************************************************************
'*  Name    : PIC_HC238.BAS                                     *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2019 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 27/05/2019                                        *
'*  Version : 1.0                                               *
'*  Notes   : Running time < 4 uS                               *
'*          : Xtal 8 Mhz                                        *
'*          : 3 inputs to 8 outputs Decoder                     *
'****************************************************************


'/------------------------------------------------------------------------------
    Device = 16F54
    Declare Xtal 8
    Declare Watchdog On

    Config HS_OSC, WDT_ON, CP_ON
'/------------------------------------------------------------------------------
'/ Declare Input Pins
    $define A0 PORTA.0
    $define A1 PORTA.1    
    $define A2 PORTA.2
    
'/ Declare Output Pins
    $define Y0 PORTB.0
    $define Y1 PORTB.1    
    $define Y2 PORTB.2
    $define Y3 PORTB.3
    $define Y4 PORTB.4    
    $define Y5 PORTB.5 
    $define Y6 PORTB.6
    $define Y7 PORTB.7   
'/------------------------------------------------------------------------------
'/ Declare variables.
    Dim PORTINPUT As Byte
    $define PORTOUTPUT PORTB
'/------------------------------------------------------------------------------
    TRISA = %00000111    
    TRISB = %00000000
'/==============================================================================
START_DECODER:
    Do
        PORTINPUT = PORTA & %00000111
        PORTOUTPUT = LookUp PORTINPUT,[%00000001,%00000010,%00000100,%00001000,_
        %00010000,%00100000,%01000000,%10000000]
    Loop
'/============================================================================== 
    End                
'/============================================================================== 

